Assignee: Go MAEDA % Done: 0%

Category: Custom fields Estimated time: 0.00 hour

Target version: 4.1.0   

Resolution:    

Description

For issue custom fields, one can already select which roles should be allowed to view this field.

This patch, developed at Planio and sponsored by SDZeCOM GmbH, introduces the same setting for project and version custom

fields.

Related issues:

Related to Redmine - Feature #5037: Role-based issue custom field visibility Closed 2010-03-10

Related to Redmine - Feature #31859: Per role visibility settings for spent t... Closed

Related to Redmine - Feature #31925: Per role visibility settings for project... Closed

Related to Redmine - Patch #31954: Reject project/version custom field values... Closed

Has duplicate Redmine - Feature #15416: Role-based issue custom field visibil... Closed

Associated revisions

Revision 18386 - 2019-08-24 10:50 - Go MAEDA

Per role visibility settings for version custom fields (#23997).

Patch by Jens Krämer and Marius BALTEANU.

Revision 18387 - 2019-08-24 11:35 - Go MAEDA

Add VersionsCustomFieldsVisibilityTest (#23997).

Patch by Marius BALTEANU.

Revision 18402 - 2019-08-27 12:44 - Go MAEDA

Reject version custom field values not visible for the user (#31954, #23997).

Patch by Marius BALTEANU.

Revision 19328 - 2019-12-03 07:08 - Go MAEDA

Merged r19327 from trunk to 4.1-stable ( #32540, #31954, #23997).

History

#1 - 2016-10-05 08:45 - Jan from Planio www.plan.io

- Target version set to Candidate for next minor release

#2 - 2016-10-05 11:08 - Jens Krämer

- File 0001-per-role-visibility-settings-for-project-and-version.patch added

turns out the patch led to invalid SQL for project custom fields, here is an updated version which overrides

CustomField#visibility_by_project_condition in ProjectCustomField to work with the correct project_key (that is, projects.id instead of

projects.project_id).

#3 - 2016-11-02 04:00 - Toshi MARUYAMA

- Related to Feature #5037: Role-based issue custom field visibility added
#4 - 2016-11-02 04:03 - Toshi MARUYAMA

Could you add tests like r12012?

#5 - 2017-05-18 09:21 - Mariusz Zielinski

Hello,

When we may expect custome fields per role visibility available? (this could be really powerfull feature)

#6 - 2019-05-06 10:33 - Go MAEDA

- Category set to Custom fields

#7 - 2019-08-06 02:15 - Go MAEDA

- Has duplicate Feature #15416: Role-based issue custom field visibility for projects added

#8 - 2019-08-07 08:03 - Marius BĂLTEANU

- Related to Feature #31859: Per role visibility settings for spent time custom fields added

#9 - 2019-08-07 08:19 - Marius BĂLTEANU

- Assignee set to Marius BĂLTEANU

I'll update these patches in order to be applied on top of #31859. Jens Krämer, maybe you'll have time to review my work.

#10 - 2019-08-12 14:39 - Jens Krämer

Sure!

#11 - 2019-08-13 00:01 - Marius BĂLTEANU

- File 0001-Per-role-visibility-settings-for-project-custom-fiel.patch added

I've attached the patch that adds per role visibility settings for project.

Working on it, I've observed an inconsistent behaviour (which I consider it a defect/security issue), the project custom fields not visible for normal

users are still visible in project settings for those users who have access to project settings. This issue can be easily reproduced using the test

test_settings_should_not_display_custom_fields_not_visible_for_user added by me in test/functional/projects_controller_test.

Also, in order to keep the current behaviour where a custom field can be displayed in project#show only for admin users, we cannot validate the roles

values when saving a project custom field (as we do for issues/spent entries) in order to allow saving a custom field with "to these roles only:"

checked, but without any role checked (which is the equivalent of visible: false). Otherwise, we need to add a new option to visibility in order to allow

"admin only".

Tests pass: https://gitlab.com/redmine-org/redmine/pipelines/76036437

Jens Krämer, Go Maeda, what do you think about these changes?

#12 - 2019-08-19 07:16 - Go MAEDA

Marius BALTEANU wrote:

Working on it, I've observed an inconsistent behaviour (which I consider it a defect/security issue), the project custom fields not visible for normal

users are still visible in project settings for those users who have access to project settings.

 The behavior will be fixed by your patch and the new behavior is straightforward.

Also, in order to keep the current behaviour where a custom field can be displayed in project#show only for admin users, we cannot validate the

roles values when saving a project custom field (as we do for issues/spent entries) in order to allow saving a custom field with "to these roles

only:" checked, but without any role checked (which is the equivalent of visible: false).

 I think it is OK.

#13 - 2019-08-19 08:17 - Jens Krämer

Looks good to me!

#14 - 2019-08-19 22:18 - Marius BĂLTEANU

- Related to Feature #31925: Per role visibility settings for project custom fields added
#15 - 2019-08-20 22:30 - Marius BĂLTEANU

- File 0001-Per-role-visibility-for-version-custom-fields.patch added

- Subject changed from Per role visibility settings for project and version custom fields to Per role visibility settings for version custom fields

Attached the patch for version custom fields.

Jens, do you remember why did you override the @safe_attributes= method in your proposed patch for Version?

Tests pass: https://gitlab.com/redmine-org/redmine/pipelines/77404580

#16 - 2019-08-21 21:07 - Jens Krämer

Marius Ionescu - From the looks of it I would say I did that to prevent a user from setting the values of fields they cannot see through a crafted

request. The same logic is present in the issue model. strictly speaking the same should be done for projects.

#17 - 2019-08-23 21:42 - Marius BĂLTEANU

- Assignee deleted (Marius BĂLTEANU)

- Target version changed from Candidate for next minor release to 4.1.0

Jens Krämer wrote:

Marius Ionescu - From the looks of it I would say I did that to prevent a user from setting the values of fields they cannot see through a crafted

request. The same logic is present in the issue model. strictly speaking the same should be done for projects.

 Got it, thanks. Next week I’ll add new patches to implement this logic to Spent time, Project and Version.

Until then, we can deliver this one.

#18 - 2019-08-24 10:51 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the patch. Thank you for your contribution.

#19 - 2019-08-27 09:20 - Marius BĂLTEANU

- Related to Patch #31954: Reject project/version custom field values not visible to user added

#20 - 2019-12-20 10:06 - Jean-Philippe Lang

- Tracker changed from Patch to Feature

Files

0001-per-role-visibility-settings-for-project-and-version.patch 9.7 KB 2016-10-05 Jens Krämer

0001-per-role-visibility-settings-for-project-and-version.patch 9.9 KB 2016-10-05 Jens Krämer

0001-Per-role-visibility-settings-for-project-custom-fiel.patch 4.95 KB 2019-08-12 Marius BĂLTEANU

0001-Per-role-visibility-for-version-custom-fields.patch 8.63 KB 2019-08-20 Marius BĂLTEANU
